/* notifications-capability.c generated by valac 0.56.17, the Vala compiler
 * generated from notifications-capability.vala, do not modify */

/*
 * Copyright (c) 2016 gnome-pomodoro contributors
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 * Authors: Kamil Prusko <kamilprusko@gmail.com>
 *
 */

#include "gnome-pomodoro.h"
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <config.h>
#include <math.h>
#include <float.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

typedef GDBusProxy FreedesktopNotificationsProxy;
typedef GDBusProxyClass FreedesktopNotificationsProxyClass;
enum  {
	POMODORO_NOTIFICATIONS_CAPABILITY_0_PROPERTY,
	POMODORO_NOTIFICATIONS_CAPABILITY_NUM_PROPERTIES
};
static GParamSpec* pomodoro_notifications_capability_properties[POMODORO_NOTIFICATIONS_CAPABILITY_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))

struct _PomodoroNotificationsCapabilityPrivate {
	GSettings* settings;
	PomodoroTimer* timer;
	PomodoroScreenNotification* screen_notification;
	guint watcher_id;
	gboolean have_actions;
	gboolean have_persistence;
};

static gint PomodoroNotificationsCapability_private_offset;
static gpointer pomodoro_notifications_capability_parent_class = NULL;

static GType freedesktop_notifications_get_type_once (void);
static void freedesktop_notifications_proxy_g_signal (GDBusProxy* proxy,
                                               const gchar* sender_name,
                                               const gchar* signal_name,
                                               GVariant* parameters);
static void freedesktop_notifications_proxy_get_capabilities (FreedesktopNotifications* self,
                                                       gchar*** capabilities,
                                                       gint* capabilities_length1,
                                                       GError** error);
static void freedesktop_notifications_proxy_freedesktop_notifications_interface_init (FreedesktopNotificationsIface* iface);
static void _dbus_freedesktop_notifications_get_capabilities (FreedesktopNotifications* self,
                                                       GVariant* _parameters_,
                                                       GDBusMethodInvocation* invocation);
static void freedesktop_notifications_dbus_interface_method_call (GDBusConnection* connection,
                                                           const gchar* sender,
                                                           const gchar* object_path,
                                                           const gchar* interface_name,
                                                           const gchar* method_name,
                                                           GVariant* parameters,
                                                           GDBusMethodInvocation* invocation,
                                                           gpointer user_data);
static GVariant* freedesktop_notifications_dbus_interface_get_property (GDBusConnection* connection,
                                                                 const gchar* sender,
                                                                 const gchar* object_path,
                                                                 const gchar* interface_name,
                                                                 const gchar* property_name,
                                                                 GError** error,
                                                                 gpointer user_data);
static gboolean freedesktop_notifications_dbus_interface_set_property (GDBusConnection* connection,
                                                                const gchar* sender,
                                                                const gchar* object_path,
                                                                const gchar* interface_name,
                                                                const gchar* property_name,
                                                                GVariant* value,
                                                                GError** error,
                                                                gpointer user_data);
static void _freedesktop_notifications_unregister_object (gpointer user_data);
static void pomodoro_notifications_capability_on_name_appeared (PomodoroNotificationsCapability* self,
                                                         GDBusConnection* connection,
                                                         const gchar* name,
                                                         const gchar* name_owner);
static void pomodoro_notifications_capability_on_name_vanished (PomodoroNotificationsCapability* self,
                                                         GDBusConnection* connection,
                                                         const gchar* name);
static void pomodoro_notifications_capability_notify_pomodoro_start (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_show_pomodoro_start_notification (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_notify_pomodoro_end (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_show_screen_notification (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_show_pomodoro_end_notification (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_withdraw_notifications (PomodoroNotificationsCapability* self);
static void ___lambda35_ (PomodoroNotificationsCapability* self);
static void ____lambda35__gtk_widget_destroy (GtkWidget* _sender,
                                       gpointer self);
static void pomodoro_notifications_capability_on_settings_changed (PomodoroNotificationsCapability* self,
                                                            GSettings* settings,
                                                            const gchar* key);
static void pomodoro_notifications_capability_on_timer_state_changed (PomodoroNotificationsCapability* self,
                                                               PomodoroTimerState* state,
                                                               PomodoroTimerState* previous_state);
static void pomodoro_notifications_capability_on_timer_state_duration_notify (PomodoroNotificationsCapability* self);
static void pomodoro_notifications_capability_on_timer_is_paused_notify (PomodoroNotificationsCapability* self);
static gboolean ___lambda36_ (PomodoroNotificationsCapability* self);
static gboolean ____lambda36__gsource_func (gpointer self);
static void pomodoro_notifications_capability_on_show_screen_notification_activate (PomodoroNotificationsCapability* self,
                                                                             GSimpleAction* action,
                                                                             GVariant* parameter);
static void pomodoro_notifications_capability_real_enable (PomodoroCapability* base);
static void _pomodoro_notifications_capability_on_show_screen_notification_activate_g_simple_action_activate (GSimpleAction* _sender,
                                                                                                       GVariant* parameter,
                                                                                                       gpointer self);
static void _pomodoro_notifications_capability_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender,
                                                                                             PomodoroTimerState* state,
                                                                                             PomodoroTimerState* previous_state,
                                                                                             gpointer self);
static void _pomodoro_notifications_capability_on_timer_state_duration_notify_g_object_notify (GObject* _sender,
                                                                                        GParamSpec* pspec,
                                                                                        gpointer self);
static void _pomodoro_notifications_capability_on_timer_is_paused_notify_g_object_notify (GObject* _sender,
                                                                                   GParamSpec* pspec,
                                                                                   gpointer self);
static void _pomodoro_notifications_capability_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                                const gchar* key,
                                                                                gpointer self);
static void pomodoro_notifications_capability_real_disable (PomodoroCapability* base);
static void pomodoro_notifications_capability_real_dispose (GObject* base);
static GObject * pomodoro_notifications_capability_constructor (GType type,
                                                         guint n_construct_properties,
                                                         GObjectConstructParam * construct_properties);
static void _pomodoro_notifications_capability_on_name_appeared_gbus_name_appeared_callback (GDBusConnection* connection,
                                                                                      const gchar* name,
                                                                                      const gchar* name_owner,
                                                                                      gpointer self);
static void _pomodoro_notifications_capability_on_name_vanished_gbus_name_vanished_callback (GDBusConnection* connection,
                                                                                      const gchar* name,
                                                                                      gpointer self);
static void pomodoro_notifications_capability_finalize (GObject * obj);
static GType pomodoro_notifications_capability_get_type_once (void);
static void _vala_array_destroy (gpointer array,
                          gssize array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gssize array_length,
                       GDestroyNotify destroy_func);

static const GDBusArgInfo _freedesktop_notifications_dbus_arg_info_get_capabilities_capabilities = {-1, "capabilities", "as", NULL};
static const GDBusArgInfo * const _freedesktop_notifications_dbus_arg_info_get_capabilities_in[] = {NULL};
static const GDBusArgInfo * const _freedesktop_notifications_dbus_arg_info_get_capabilities_out[] = {&_freedesktop_notifications_dbus_arg_info_get_capabilities_capabilities, NULL};
static const GDBusMethodInfo _freedesktop_notifications_dbus_method_info_get_capabilities = {-1, "GetCapabilities", (GDBusArgInfo **) (&_freedesktop_notifications_dbus_arg_info_get_capabilities_in), (GDBusArgInfo **) (&_freedesktop_notifications_dbus_arg_info_get_capabilities_out), NULL};
static const GDBusMethodInfo * const _freedesktop_notifications_dbus_method_info[] = {&_freedesktop_notifications_dbus_method_info_get_capabilities, NULL};
static const GDBusSignalInfo * const _freedesktop_notifications_dbus_signal_info[] = {NULL};
static const GDBusPropertyInfo * const _freedesktop_notifications_dbus_property_info[] = {NULL};
static const GDBusInterfaceInfo _freedesktop_notifications_dbus_interface_info = {-1, "org.freedesktop.Notifications", (GDBusMethodInfo **) (&_freedesktop_notifications_dbus_method_info), (GDBusSignalInfo **) (&_freedesktop_notifications_dbus_signal_info), (GDBusPropertyInfo **) (&_freedesktop_notifications_dbus_property_info), NULL};
static const GDBusInterfaceVTable _freedesktop_notifications_dbus_interface_vtable = {freedesktop_notifications_dbus_interface_method_call, freedesktop_notifications_dbus_interface_get_property, freedesktop_notifications_dbus_interface_set_property};

void
freedesktop_notifications_get_capabilities (FreedesktopNotifications* self,
                                            gchar*** capabilities,
                                            gint* capabilities_length1,
                                            GError** error)
{
	FreedesktopNotificationsIface* _iface_;
#line 29 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/notifications-capability.vala"
	_iface_ = FREEDESKTOP_NOTIFICATIONS_GET_INTERFACE (self);
#line 29 "../src/notifications-capability.vala"
	if (_iface_->get_capabilities) {
#line 29 "../src/notifications-capability.vala"
		_iface_->get_capabilities (self, capabilities, capabilities_length1, error);
#line 199 "notifications-capability.c"
	}
}

static void
freedesktop_notifications_default_init (FreedesktopNotificationsIface * iface,
                                        gpointer iface_data)
{
}

static GType
freedesktop_notifications_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (FreedesktopNotificationsIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) freedesktop_notifications_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
	GType freedesktop_notifications_type_id;
	freedesktop_notifications_type_id = g_type_register_static (G_TYPE_INTERFACE, "FreedesktopNotifications", &g_define_type_info, 0);
	g_type_interface_add_prerequisite (freedesktop_notifications_type_id, G_TYPE_OBJECT);
	g_type_set_qdata (freedesktop_notifications_type_id, g_quark_from_static_string ("vala-dbus-proxy-type"), (void*) freedesktop_notifications_proxy_get_type);
	g_type_set_qdata (freedesktop_notifications_type_id, g_quark_from_static_string ("vala-dbus-interface-name"), "org.freedesktop.Notifications");
	g_type_set_qdata (freedesktop_notifications_type_id, g_quark_from_static_string ("vala-dbus-interface-info"), (void*) (&_freedesktop_notifications_dbus_interface_info));
	g_type_set_qdata (freedesktop_notifications_type_id, g_quark_from_static_string ("vala-dbus-register-object"), (void*) freedesktop_notifications_register_object);
	return freedesktop_notifications_type_id;
}

GType
freedesktop_notifications_get_type (void)
{
	static volatile gsize freedesktop_notifications_type_id__once = 0;
	if (g_once_init_enter (&freedesktop_notifications_type_id__once)) {
		GType freedesktop_notifications_type_id;
		freedesktop_notifications_type_id = freedesktop_notifications_get_type_once ();
		g_once_init_leave (&freedesktop_notifications_type_id__once, freedesktop_notifications_type_id);
	}
	return freedesktop_notifications_type_id__once;
}

G_DEFINE_TYPE_EXTENDED (FreedesktopNotificationsProxy, freedesktop_notifications_proxy, G_TYPE_DBUS_PROXY, 0, G_IMPLEMENT_INTERFACE (FREEDESKTOP_TYPE_NOTIFICATIONS, freedesktop_notifications_proxy_freedesktop_notifications_interface_init) )
static void
freedesktop_notifications_proxy_class_init (FreedesktopNotificationsProxyClass* klass)
{
#line 29 "../src/aggregated-entry.vala"
	G_DBUS_PROXY_CLASS (klass)->g_signal = freedesktop_notifications_proxy_g_signal;
#line 241 "notifications-capability.c"
}

static void
freedesktop_notifications_proxy_g_signal (GDBusProxy* proxy,
                                          const gchar* sender_name,
                                          const gchar* signal_name,
                                          GVariant* parameters)
{
}

static void
freedesktop_notifications_proxy_init (FreedesktopNotificationsProxy* self)
{
#line 29 "../src/aggregated-entry.vala"
	g_dbus_proxy_set_interface_info (G_DBUS_PROXY (self), (GDBusInterfaceInfo *) (&_freedesktop_notifications_dbus_interface_info));
#line 257 "notifications-capability.c"
}

static void
freedesktop_notifications_proxy_get_capabilities (FreedesktopNotifications* self,
                                                  gchar*** capabilities,
                                                  gint* capabilities_length1,
                                                  GError** error)
{
	GDBusMessage *_message;
	GVariant *_arguments;
	GVariantBuilder _arguments_builder;
	GDBusMessage *_reply_message;
	GVariant *_reply;
	GVariantIter _reply_iter;
	gchar** _vala_capabilities = NULL;
	gint _vala_capabilities_length1;
	GVariant* _tmp6_;
	gchar** _tmp7_;
	gint _tmp7__length;
	gint _tmp7__size;
	gint _tmp7__length1;
	GVariantIter _tmp8_;
	GVariant* _tmp9_;
#line 29 "../src/aggregated-entry.vala"
	_message = g_dbus_message_new_method_call (g_dbus_proxy_get_name ((GDBusProxy *) self), g_dbus_proxy_get_object_path ((GDBusProxy *) self), "org.freedesktop.Notifications", "GetCapabilities");
#line 29 "../src/aggregated-entry.vala"
	g_variant_builder_init (&_arguments_builder, G_VARIANT_TYPE_TUPLE);
#line 29 "../src/aggregated-entry.vala"
	_arguments = g_variant_builder_end (&_arguments_builder);
#line 29 "../src/aggregated-entry.vala"
	g_dbus_message_set_body (_message, _arguments);
#line 29 "../src/aggregated-entry.vala"
	_reply_message = g_dbus_connection_send_message_with_reply_sync (g_dbus_proxy_get_connection ((GDBusProxy *) self), _message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, g_dbus_proxy_get_default_timeout ((GDBusProxy *) self), NULL, NULL, error);
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (_message);
#line 29 "../src/aggregated-entry.vala"
	if (!_reply_message) {
#line 29 "../src/aggregated-entry.vala"
		return;
#line 297 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	if (g_dbus_message_to_gerror (_reply_message, error)) {
#line 29 "../src/aggregated-entry.vala"
		g_object_unref (_reply_message);
#line 29 "../src/aggregated-entry.vala"
		return;
#line 305 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	_reply = g_dbus_message_get_body (_reply_message);
#line 29 "../src/aggregated-entry.vala"
	g_variant_iter_init (&_reply_iter, _reply);
#line 311 "notifications-capability.c"
	_vala_capabilities_length1 = 0;
#line 29 "../src/aggregated-entry.vala"
	_tmp6_ = g_variant_iter_next_value (&_reply_iter);
#line 315 "notifications-capability.c"
	_tmp7_ = g_new (gchar*, 5);
	_tmp7__length = 0;
	_tmp7__size = 4;
	_tmp7__length1 = 0;
#line 29 "../src/aggregated-entry.vala"
	g_variant_iter_init (&_tmp8_, _tmp6_);
#line 29 "../src/aggregated-entry.vala"
	for (; (_tmp9_ = g_variant_iter_next_value (&_tmp8_)) != NULL; _tmp7__length1++) {
#line 29 "../src/aggregated-entry.vala"
		if (_tmp7__size == _tmp7__length) {
#line 29 "../src/aggregated-entry.vala"
			_tmp7__size = 2 * _tmp7__size;
#line 29 "../src/aggregated-entry.vala"
			_tmp7_ = g_renew (gchar*, _tmp7_, _tmp7__size + 1);
#line 330 "notifications-capability.c"
		}
#line 29 "../src/aggregated-entry.vala"
		_tmp7_[_tmp7__length++] = g_variant_dup_string (_tmp9_, NULL);
#line 29 "../src/aggregated-entry.vala"
		g_variant_unref (_tmp9_);
#line 336 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	_vala_capabilities_length1 = _tmp7__length1;
#line 29 "../src/aggregated-entry.vala"
	_tmp7_[_tmp7__length] = NULL;
#line 29 "../src/aggregated-entry.vala"
	_vala_capabilities = _tmp7_;
#line 29 "../src/aggregated-entry.vala"
	g_variant_unref (_tmp6_);
#line 29 "../src/aggregated-entry.vala"
	*capabilities = _vala_capabilities;
#line 29 "../src/aggregated-entry.vala"
	*capabilities_length1 = _vala_capabilities_length1;
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (_reply_message);
#line 352 "notifications-capability.c"
}

static void
freedesktop_notifications_proxy_freedesktop_notifications_interface_init (FreedesktopNotificationsIface* iface)
{
#line 29 "../src/aggregated-entry.vala"
	iface->get_capabilities = freedesktop_notifications_proxy_get_capabilities;
#line 360 "notifications-capability.c"
}

static void
_dbus_freedesktop_notifications_get_capabilities (FreedesktopNotifications* self,
                                                  GVariant* _parameters_,
                                                  GDBusMethodInvocation* invocation)
{
	GError* error = NULL;
	GVariantIter _arguments_iter;
	GDBusMessage* _reply_message = NULL;
	GVariant* _reply;
	GVariantBuilder _reply_builder;
	gchar** capabilities = NULL;
	gint capabilities_length1 = 0;
	gchar** _tmp10_;
	GVariantBuilder _tmp11_;
	gint _tmp12_;
#line 29 "../src/aggregated-entry.vala"
	g_variant_iter_init (&_arguments_iter, _parameters_);
#line 29 "../src/aggregated-entry.vala"
	freedesktop_notifications_get_capabilities (self, &capabilities, &capabilities_length1, &error);
#line 29 "../src/aggregated-entry.vala"
	if (error) {
#line 29 "../src/aggregated-entry.vala"
		g_dbus_method_invocation_take_error (invocation, error);
#line 29 "../src/aggregated-entry.vala"
		return;
#line 388 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	_reply_message = g_dbus_message_new_method_reply (g_dbus_method_invocation_get_message (invocation));
#line 29 "../src/aggregated-entry.vala"
	g_variant_builder_init (&_reply_builder, G_VARIANT_TYPE_TUPLE);
#line 29 "../src/aggregated-entry.vala"
	_tmp10_ = capabilities;
#line 29 "../src/aggregated-entry.vala"
	g_variant_builder_init (&_tmp11_, G_VARIANT_TYPE ("as"));
#line 29 "../src/aggregated-entry.vala"
	for (_tmp12_ = 0; _tmp12_ < capabilities_length1; _tmp12_++) {
#line 29 "../src/aggregated-entry.vala"
		g_variant_builder_add_value (&_tmp11_, g_variant_new_string (*_tmp10_));
#line 29 "../src/aggregated-entry.vala"
		_tmp10_++;
#line 404 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	g_variant_builder_add_value (&_reply_builder, g_variant_builder_end (&_tmp11_));
#line 29 "../src/aggregated-entry.vala"
	_reply = g_variant_builder_end (&_reply_builder);
#line 29 "../src/aggregated-entry.vala"
	g_dbus_message_set_body (_reply_message, _reply);
#line 29 "../src/aggregated-entry.vala"
	g_dbus_connection_send_message (g_dbus_method_invocation_get_connection (invocation), _reply_message, G_DBUS_SEND_MESSAGE_FLAGS_NONE, NULL, NULL);
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (invocation);
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (_reply_message);
#line 29 "../src/aggregated-entry.vala"
	capabilities = (_vala_array_free (capabilities, capabilities_length1, (GDestroyNotify) g_free), NULL);
#line 420 "notifications-capability.c"
}

static void
freedesktop_notifications_dbus_interface_method_call (GDBusConnection* connection,
                                                      const gchar* sender,
                                                      const gchar* object_path,
                                                      const gchar* interface_name,
                                                      const gchar* method_name,
                                                      GVariant* parameters,
                                                      GDBusMethodInvocation* invocation,
                                                      gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 29 "../src/aggregated-entry.vala"
	if (strcmp (method_name, "GetCapabilities") == 0) {
#line 29 "../src/aggregated-entry.vala"
		_dbus_freedesktop_notifications_get_capabilities (object, parameters, invocation);
#line 441 "notifications-capability.c"
	} else {
#line 29 "../src/aggregated-entry.vala"
		g_object_unref (invocation);
#line 445 "notifications-capability.c"
	}
}

static GVariant*
freedesktop_notifications_dbus_interface_get_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GError** error,
                                                       gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 29 "../src/aggregated-entry.vala"
	return NULL;
#line 464 "notifications-capability.c"
}

static gboolean
freedesktop_notifications_dbus_interface_set_property (GDBusConnection* connection,
                                                       const gchar* sender,
                                                       const gchar* object_path,
                                                       const gchar* interface_name,
                                                       const gchar* property_name,
                                                       GVariant* value,
                                                       GError** error,
                                                       gpointer user_data)
{
	gpointer* data;
	gpointer object;
	data = user_data;
	object = data[0];
#line 29 "../src/aggregated-entry.vala"
	return FALSE;
#line 483 "notifications-capability.c"
}

guint
freedesktop_notifications_register_object (gpointer object,
                                           GDBusConnection* connection,
                                           const gchar* path,
                                           GError** error)
{
	guint result;
	gpointer *data;
#line 29 "../src/aggregated-entry.vala"
	data = g_new (gpointer, 3);
#line 29 "../src/aggregated-entry.vala"
	data[0] = g_object_ref (object);
#line 29 "../src/aggregated-entry.vala"
	data[1] = g_object_ref (connection);
#line 29 "../src/aggregated-entry.vala"
	data[2] = g_strdup (path);
#line 29 "../src/aggregated-entry.vala"
	result = g_dbus_connection_register_object (connection, path, (GDBusInterfaceInfo *) (&_freedesktop_notifications_dbus_interface_info), &_freedesktop_notifications_dbus_interface_vtable, data, _freedesktop_notifications_unregister_object, error);
#line 29 "../src/aggregated-entry.vala"
	if (!result) {
#line 29 "../src/aggregated-entry.vala"
		return 0;
#line 508 "notifications-capability.c"
	}
#line 29 "../src/aggregated-entry.vala"
	return result;
#line 512 "notifications-capability.c"
}

static void
_freedesktop_notifications_unregister_object (gpointer user_data)
{
	gpointer* data;
	data = user_data;
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (data[0]);
#line 29 "../src/aggregated-entry.vala"
	g_object_unref (data[1]);
#line 29 "../src/aggregated-entry.vala"
	g_free (data[2]);
#line 29 "../src/aggregated-entry.vala"
	g_free (data);
#line 528 "notifications-capability.c"
}

static inline gpointer
pomodoro_notifications_capability_get_instance_private (PomodoroNotificationsCapability* self)
{
	return G_STRUCT_MEMBER_P (self, PomodoroNotificationsCapability_private_offset);
}

PomodoroNotificationsCapability*
pomodoro_notifications_capability_construct (GType object_type,
                                             const gchar* name)
{
	PomodoroNotificationsCapability * self = NULL;
#line 56 "../src/notifications-capability.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 58 "../src/notifications-capability.vala"
	self = (PomodoroNotificationsCapability*) pomodoro_capability_construct (object_type, name, NULL, NULL, NULL, NULL, NULL, NULL);
#line 56 "../src/notifications-capability.vala"
	return self;
#line 548 "notifications-capability.c"
}

PomodoroNotificationsCapability*
pomodoro_notifications_capability_new (const gchar* name)
{
#line 56 "../src/notifications-capability.vala"
	return pomodoro_notifications_capability_construct (POMODORO_TYPE_NOTIFICATIONS_CAPABILITY, name);
#line 556 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_on_name_appeared (PomodoroNotificationsCapability* self,
                                                    GDBusConnection* connection,
                                                    const gchar* name,
                                                    const gchar* name_owner)
{
	gchar** capabilities = NULL;
	gint capabilities_length1 = 0;
	gint _capabilities_size_ = 0;
	GError* _inner_error0_ = NULL;
#line 61 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 61 "../src/notifications-capability.vala"
	g_return_if_fail (connection != NULL);
#line 61 "../src/notifications-capability.vala"
	g_return_if_fail (name != NULL);
#line 61 "../src/notifications-capability.vala"
	g_return_if_fail (name_owner != NULL);
#line 577 "notifications-capability.c"
	{
		FreedesktopNotifications* proxy = NULL;
		FreedesktopNotifications* _tmp0_;
		FreedesktopNotifications* _tmp1_;
		gchar** _tmp2_ = NULL;
		gint _tmp3_ = 0;
#line 68 "../src/notifications-capability.vala"
		_tmp0_ = (FreedesktopNotifications*) g_initable_new (FREEDESKTOP_TYPE_NOTIFICATIONS_PROXY, NULL, &_inner_error0_, "g-flags", G_DBUS_PROXY_FLAGS_DO_NOT_AUTO_START | G_DBUS_PROXY_FLAGS_DO_NOT_CONNECT_SIGNALS, "g-name", "org.freedesktop.Notifications", "g-bus-type", G_BUS_TYPE_SESSION, "g-object-path", "/org/freedesktop/Notifications", "g-interface-name", "org.freedesktop.Notifications", NULL);
#line 68 "../src/notifications-capability.vala"
		proxy = (FreedesktopNotifications*) _tmp0_;
#line 68 "../src/notifications-capability.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 590 "notifications-capability.c"
			goto __catch0_g_error;
		}
#line 73 "../src/notifications-capability.vala"
		_tmp1_ = proxy;
#line 73 "../src/notifications-capability.vala"
		freedesktop_notifications_get_capabilities (_tmp1_, &_tmp2_, &_tmp3_, &_inner_error0_);
#line 73 "../src/notifications-capability.vala"
		capabilities = (_vala_array_free (capabilities, capabilities_length1, (GDestroyNotify) g_free), NULL);
#line 73 "../src/notifications-capability.vala"
		capabilities = _tmp2_;
#line 73 "../src/notifications-capability.vala"
		capabilities_length1 = _tmp3_;
#line 73 "../src/notifications-capability.vala"
		_capabilities_size_ = capabilities_length1;
#line 73 "../src/notifications-capability.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 73 "../src/notifications-capability.vala"
			_g_object_unref0 (proxy);
#line 609 "notifications-capability.c"
			goto __catch0_g_error;
		}
		{
			gint i = 0;
#line 75 "../src/notifications-capability.vala"
			i = 0;
#line 616 "notifications-capability.c"
			{
				gboolean _tmp4_ = FALSE;
#line 75 "../src/notifications-capability.vala"
				_tmp4_ = TRUE;
#line 75 "../src/notifications-capability.vala"
				while (TRUE) {
#line 623 "notifications-capability.c"
					gchar** _tmp6_;
					gint _tmp6__length1;
					gchar** _tmp7_;
					gint _tmp7__length1;
					const gchar* _tmp8_;
					const gchar* _tmp9_;
					GQuark _tmp11_ = 0U;
#line 76 "../src/notifications-capability.vala"
					static GQuark _tmp10_label0 = 0;
#line 76 "../src/notifications-capability.vala"
					static GQuark _tmp10_label1 = 0;
#line 75 "../src/notifications-capability.vala"
					if (!_tmp4_) {
#line 637 "notifications-capability.c"
						gint _tmp5_;
#line 75 "../src/notifications-capability.vala"
						_tmp5_ = i;
#line 75 "../src/notifications-capability.vala"
						i = _tmp5_ + 1;
#line 643 "notifications-capability.c"
					}
#line 75 "../src/notifications-capability.vala"
					_tmp4_ = FALSE;
#line 75 "../src/notifications-capability.vala"
					_tmp6_ = capabilities;
#line 75 "../src/notifications-capability.vala"
					_tmp6__length1 = capabilities_length1;
#line 75 "../src/notifications-capability.vala"
					if (!(i < _tmp6__length1)) {
#line 75 "../src/notifications-capability.vala"
						break;
#line 655 "notifications-capability.c"
					}
#line 76 "../src/notifications-capability.vala"
					_tmp7_ = capabilities;
#line 76 "../src/notifications-capability.vala"
					_tmp7__length1 = capabilities_length1;
#line 76 "../src/notifications-capability.vala"
					_tmp8_ = _tmp7_[i];
#line 76 "../src/notifications-capability.vala"
					_tmp9_ = _tmp8_;
#line 76 "../src/notifications-capability.vala"
					_tmp11_ = (NULL == _tmp9_) ? 0 : g_quark_from_string (_tmp9_);
#line 76 "../src/notifications-capability.vala"
					if (_tmp11_ == ((0 != _tmp10_label0) ? _tmp10_label0 : (_tmp10_label0 = g_quark_from_static_string ("actions")))) {
#line 76 "../src/notifications-capability.vala"
						switch (0) {
#line 671 "notifications-capability.c"
							default:
							{
#line 78 "../src/notifications-capability.vala"
								self->priv->have_actions = TRUE;
#line 79 "../src/notifications-capability.vala"
								break;
#line 678 "notifications-capability.c"
							}
						}
					} else if (_tmp11_ == ((0 != _tmp10_label1) ? _tmp10_label1 : (_tmp10_label1 = g_quark_from_static_string ("persistence")))) {
#line 76 "../src/notifications-capability.vala"
						switch (0) {
#line 684 "notifications-capability.c"
							default:
							{
#line 82 "../src/notifications-capability.vala"
								self->priv->have_persistence = TRUE;
#line 83 "../src/notifications-capability.vala"
								break;
#line 691 "notifications-capability.c"
							}
						}
					}
				}
			}
		}
#line 67 "../src/notifications-capability.vala"
		_g_object_unref0 (proxy);
#line 700 "notifications-capability.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp12_;
		const gchar* _tmp13_;
#line 67 "../src/notifications-capability.vala"
		_error_ = _inner_error0_;
#line 67 "../src/notifications-capability.vala"
		_inner_error0_ = NULL;
#line 88 "../src/notifications-capability.vala"
		_tmp12_ = _error_;
#line 88 "../src/notifications-capability.vala"
		_tmp13_ = _tmp12_->message;
#line 88 "../src/notifications-capability.vala"
		g_warning ("notifications-capability.vala:88: Error getting notification capabilit" \
"ies: %s", _tmp13_);
#line 67 "../src/notifications-capability.vala"
		_g_error_free0 (_error_);
#line 720 "notifications-capability.c"
	}
	__finally0:
#line 67 "../src/notifications-capability.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 67 "../src/notifications-capability.vala"
		capabilities = (_vala_array_free (capabilities, capabilities_length1, (GDestroyNotify) g_free), NULL);
#line 67 "../src/notifications-capability.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 67 "../src/notifications-capability.vala"
		g_clear_error (&_inner_error0_);
#line 67 "../src/notifications-capability.vala"
		return;
#line 733 "notifications-capability.c"
	}
#line 61 "../src/notifications-capability.vala"
	capabilities = (_vala_array_free (capabilities, capabilities_length1, (GDestroyNotify) g_free), NULL);
#line 737 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_on_name_vanished (PomodoroNotificationsCapability* self,
                                                    GDBusConnection* connection,
                                                    const gchar* name)
{
#line 92 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/notifications-capability.vala"
	g_return_if_fail (connection != NULL);
#line 92 "../src/notifications-capability.vala"
	g_return_if_fail (name != NULL);
#line 751 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_notify_pomodoro_start (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 97 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 99 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 99 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 99 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 99 "../src/notifications-capability.vala"
	if (!_tmp2_) {
#line 100 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_show_pomodoro_start_notification (self);
#line 772 "notifications-capability.c"
	}
}

static void
pomodoro_notifications_capability_notify_pomodoro_end (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 104 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 106 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 106 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 106 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 106 "../src/notifications-capability.vala"
	if (!_tmp2_) {
#line 792 "notifications-capability.c"
		GSettings* _tmp3_;
#line 107 "../src/notifications-capability.vala"
		_tmp3_ = self->priv->settings;
#line 107 "../src/notifications-capability.vala"
		if (g_settings_get_boolean (_tmp3_, "show-screen-notifications")) {
#line 108 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_show_screen_notification (self);
#line 800 "notifications-capability.c"
		} else {
#line 111 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_show_pomodoro_end_notification (self);
#line 804 "notifications-capability.c"
		}
	}
}

static void
pomodoro_notifications_capability_withdraw_notifications (PomodoroNotificationsCapability* self)
{
	PomodoroScreenNotification* _tmp0_;
	GApplication* _tmp2_;
#line 116 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 118 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->screen_notification;
#line 118 "../src/notifications-capability.vala"
	if (_tmp0_ != NULL) {
#line 820 "notifications-capability.c"
		PomodoroScreenNotification* _tmp1_;
#line 119 "../src/notifications-capability.vala"
		_tmp1_ = self->priv->screen_notification;
#line 119 "../src/notifications-capability.vala"
		pomodoro_screen_notification_close (_tmp1_);
#line 826 "notifications-capability.c"
	}
#line 122 "../src/notifications-capability.vala"
	_tmp2_ = g_application_get_default ();
#line 122 "../src/notifications-capability.vala"
	g_application_withdraw_notification (_tmp2_, "timer");
#line 832 "notifications-capability.c"
}

static void
___lambda35_ (PomodoroNotificationsCapability* self)
{
	gboolean _tmp0_ = FALSE;
	PomodoroTimer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 131 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->screen_notification);
#line 131 "../src/notifications-capability.vala"
	self->priv->screen_notification = NULL;
#line 133 "../src/notifications-capability.vala"
	_tmp1_ = self->priv->timer;
#line 133 "../src/notifications-capability.vala"
	_tmp2_ = pomodoro_timer_get_is_paused (_tmp1_);
#line 133 "../src/notifications-capability.vala"
	_tmp3_ = _tmp2_;
#line 133 "../src/notifications-capability.vala"
	if (!_tmp3_) {
#line 854 "notifications-capability.c"
		PomodoroTimer* _tmp4_;
		PomodoroTimerState* _tmp5_;
		PomodoroTimerState* _tmp6_;
#line 133 "../src/notifications-capability.vala"
		_tmp4_ = self->priv->timer;
#line 133 "../src/notifications-capability.vala"
		_tmp5_ = pomodoro_timer_get_state (_tmp4_);
#line 133 "../src/notifications-capability.vala"
		_tmp6_ = _tmp5_;
#line 133 "../src/notifications-capability.vala"
		_tmp0_ = POMODORO_IS_BREAK_STATE (_tmp6_);
#line 866 "notifications-capability.c"
	} else {
#line 133 "../src/notifications-capability.vala"
		_tmp0_ = FALSE;
#line 870 "notifications-capability.c"
	}
#line 133 "../src/notifications-capability.vala"
	if (_tmp0_) {
#line 134 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_show_pomodoro_end_notification (self);
#line 876 "notifications-capability.c"
	}
}

static void
____lambda35__gtk_widget_destroy (GtkWidget* _sender,
                                  gpointer self)
{
#line 130 "../src/notifications-capability.vala"
	___lambda35_ ((PomodoroNotificationsCapability*) self);
#line 886 "notifications-capability.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 139 "../src/notifications-capability.vala"
	return self ? g_object_ref (self) : NULL;
#line 894 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_show_screen_notification (PomodoroNotificationsCapability* self)
{
	PomodoroScreenNotification* _tmp0_;
	PomodoroApplication* application = NULL;
	PomodoroApplication* _tmp3_;
	PomodoroApplication* _tmp4_;
	PomodoroScreenNotification* _tmp5_;
	PomodoroScreenNotification* _tmp6_;
#line 126 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 128 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->screen_notification;
#line 128 "../src/notifications-capability.vala"
	if (_tmp0_ == NULL) {
#line 912 "notifications-capability.c"
		PomodoroScreenNotification* _tmp1_;
		PomodoroScreenNotification* _tmp2_;
#line 129 "../src/notifications-capability.vala"
		_tmp1_ = pomodoro_screen_notification_new ();
#line 129 "../src/notifications-capability.vala"
		g_object_ref_sink (_tmp1_);
#line 129 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->screen_notification);
#line 129 "../src/notifications-capability.vala"
		self->priv->screen_notification = _tmp1_;
#line 130 "../src/notifications-capability.vala"
		_tmp2_ = self->priv->screen_notification;
#line 130 "../src/notifications-capability.vala"
		g_signal_connect_object ((GtkWidget*) _tmp2_, "destroy", (GCallback) ____lambda35__gtk_widget_destroy, self, 0);
#line 927 "notifications-capability.c"
	}
#line 139 "../src/notifications-capability.vala"
	_tmp3_ = pomodoro_application_get_default ();
#line 139 "../src/notifications-capability.vala"
	_tmp4_ = _g_object_ref0 (_tmp3_);
#line 139 "../src/notifications-capability.vala"
	application = _tmp4_;
#line 140 "../src/notifications-capability.vala"
	_tmp5_ = self->priv->screen_notification;
#line 140 "../src/notifications-capability.vala"
	gtk_application_add_window ((GtkApplication*) application, (GtkWindow*) _tmp5_);
#line 142 "../src/notifications-capability.vala"
	_tmp6_ = self->priv->screen_notification;
#line 142 "../src/notifications-capability.vala"
	gtk_window_present ((GtkWindow*) _tmp6_);
#line 126 "../src/notifications-capability.vala"
	_g_object_unref0 (application);
#line 945 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_show_pomodoro_start_notification (PomodoroNotificationsCapability* self)
{
	GNotification* notification = NULL;
	GNotification* _tmp0_;
	GApplication* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 145 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 147 "../src/notifications-capability.vala"
	_tmp0_ = g_notification_new (_ ("Pomodoro"));
#line 147 "../src/notifications-capability.vala"
	notification = _tmp0_;
#line 148 "../src/notifications-capability.vala"
	g_notification_set_body (notification, _ ("Focus on your task."));
#line 149 "../src/notifications-capability.vala"
	g_notification_set_priority (notification, G_NOTIFICATION_PRIORITY_HIGH);
#line 965 "notifications-capability.c"
	{
		GIcon* _tmp1_ = NULL;
		GIcon* _tmp2_;
#line 152 "../src/notifications-capability.vala"
		_tmp2_ = g_icon_new_for_string (PACKAGE_NAME, &_inner_error0_);
#line 152 "../src/notifications-capability.vala"
		_tmp1_ = _tmp2_;
#line 152 "../src/notifications-capability.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 975 "notifications-capability.c"
			goto __catch0_g_error;
		}
#line 152 "../src/notifications-capability.vala"
		g_notification_set_icon (notification, _tmp1_);
#line 151 "../src/notifications-capability.vala"
		_g_object_unref0 (_tmp1_);
#line 982 "notifications-capability.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp3_;
		const gchar* _tmp4_;
#line 151 "../src/notifications-capability.vala"
		_error_ = _inner_error0_;
#line 151 "../src/notifications-capability.vala"
		_inner_error0_ = NULL;
#line 155 "../src/notifications-capability.vala"
		_tmp3_ = _error_;
#line 155 "../src/notifications-capability.vala"
		_tmp4_ = _tmp3_->message;
#line 155 "../src/notifications-capability.vala"
		g_warning ("notifications-capability.vala:155: %s", _tmp4_);
#line 151 "../src/notifications-capability.vala"
		_g_error_free0 (_error_);
#line 1002 "notifications-capability.c"
	}
	__finally0:
#line 151 "../src/notifications-capability.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 151 "../src/notifications-capability.vala"
		_g_object_unref0 (notification);
#line 151 "../src/notifications-capability.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 151 "../src/notifications-capability.vala"
		g_clear_error (&_inner_error0_);
#line 151 "../src/notifications-capability.vala"
		return;
#line 1015 "notifications-capability.c"
	}
#line 158 "../src/notifications-capability.vala"
	if (self->priv->have_actions) {
#line 159 "../src/notifications-capability.vala"
		g_notification_add_button (notification, _ ("Take a break"), "app.timer-skip");
#line 1021 "notifications-capability.c"
	}
#line 162 "../src/notifications-capability.vala"
	_tmp5_ = g_application_get_default ();
#line 162 "../src/notifications-capability.vala"
	g_application_send_notification (_tmp5_, "timer", notification);
#line 145 "../src/notifications-capability.vala"
	_g_object_unref0 (notification);
#line 1029 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_show_pomodoro_end_notification (PomodoroNotificationsCapability* self)
{
	gint remaining = 0;
	PomodoroTimer* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gint minutes = 0;
	gint seconds = 0;
	gchar* _tmp3_ = NULL;
	gchar* body = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	PomodoroTimer* _tmp8_;
	PomodoroTimerState* _tmp9_;
	PomodoroTimerState* _tmp10_;
	GNotification* notification = NULL;
	GNotification* _tmp11_;
	const gchar* _tmp12_;
	GApplication* _tmp26_;
	GError* _inner_error0_ = NULL;
#line 166 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 170 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_remaining (_tmp0_);
#line 170 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 170 "../src/notifications-capability.vala"
	remaining = (gint) ceil (_tmp2_);
#line 171 "../src/notifications-capability.vala"
	minutes = (gint) round (((gdouble) remaining) / 60.0);
#line 172 "../src/notifications-capability.vala"
	seconds = (gint) floor ((gdouble) (remaining % 60));
#line 173 "../src/notifications-capability.vala"
	if (remaining > 45) {
#line 1069 "notifications-capability.c"
		gchar* _tmp4_;
#line 174 "../src/notifications-capability.vala"
		_tmp4_ = g_strdup_printf (ngettext ("You have %d minute", "You have %d minutes", (gulong) minutes), minutes);
#line 174 "../src/notifications-capability.vala"
		_g_free0 (_tmp3_);
#line 174 "../src/notifications-capability.vala"
		_tmp3_ = _tmp4_;
#line 1077 "notifications-capability.c"
	} else {
		gchar* _tmp5_;
#line 176 "../src/notifications-capability.vala"
		_tmp5_ = g_strdup_printf (ngettext ("You have %d second", "You have %d seconds", (gulong) seconds), seconds);
#line 176 "../src/notifications-capability.vala"
		_g_free0 (_tmp3_);
#line 176 "../src/notifications-capability.vala"
		_tmp3_ = _tmp5_;
#line 1086 "notifications-capability.c"
	}
#line 173 "../src/notifications-capability.vala"
	_tmp6_ = g_strdup (_tmp3_);
#line 173 "../src/notifications-capability.vala"
	body = _tmp6_;
#line 179 "../src/notifications-capability.vala"
	_tmp8_ = self->priv->timer;
#line 179 "../src/notifications-capability.vala"
	_tmp9_ = pomodoro_timer_get_state (_tmp8_);
#line 179 "../src/notifications-capability.vala"
	_tmp10_ = _tmp9_;
#line 179 "../src/notifications-capability.vala"
	if (POMODORO_IS_SHORT_BREAK_STATE (_tmp10_)) {
#line 180 "../src/notifications-capability.vala"
		_tmp7_ = _ ("Take a break");
#line 1102 "notifications-capability.c"
	} else {
#line 181 "../src/notifications-capability.vala"
		_tmp7_ = _ ("Take a longer break");
#line 1106 "notifications-capability.c"
	}
#line 179 "../src/notifications-capability.vala"
	_tmp11_ = g_notification_new (_tmp7_);
#line 179 "../src/notifications-capability.vala"
	notification = _tmp11_;
#line 182 "../src/notifications-capability.vala"
	_tmp12_ = body;
#line 182 "../src/notifications-capability.vala"
	g_notification_set_body (notification, _tmp12_);
#line 183 "../src/notifications-capability.vala"
	g_notification_set_priority (notification, G_NOTIFICATION_PRIORITY_HIGH);
#line 1118 "notifications-capability.c"
	{
		GIcon* _tmp13_ = NULL;
		GIcon* _tmp14_;
#line 186 "../src/notifications-capability.vala"
		_tmp14_ = g_icon_new_for_string (PACKAGE_NAME, &_inner_error0_);
#line 186 "../src/notifications-capability.vala"
		_tmp13_ = _tmp14_;
#line 186 "../src/notifications-capability.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1128 "notifications-capability.c"
			goto __catch0_g_error;
		}
#line 186 "../src/notifications-capability.vala"
		g_notification_set_icon (notification, _tmp13_);
#line 185 "../src/notifications-capability.vala"
		_g_object_unref0 (_tmp13_);
#line 1135 "notifications-capability.c"
	}
	goto __finally0;
	__catch0_g_error:
	{
		GError* _error_ = NULL;
		GError* _tmp15_;
		const gchar* _tmp16_;
#line 185 "../src/notifications-capability.vala"
		_error_ = _inner_error0_;
#line 185 "../src/notifications-capability.vala"
		_inner_error0_ = NULL;
#line 189 "../src/notifications-capability.vala"
		_tmp15_ = _error_;
#line 189 "../src/notifications-capability.vala"
		_tmp16_ = _tmp15_->message;
#line 189 "../src/notifications-capability.vala"
		g_warning ("notifications-capability.vala:189: %s", _tmp16_);
#line 185 "../src/notifications-capability.vala"
		_g_error_free0 (_error_);
#line 1155 "notifications-capability.c"
	}
	__finally0:
#line 185 "../src/notifications-capability.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 185 "../src/notifications-capability.vala"
		_g_object_unref0 (notification);
#line 185 "../src/notifications-capability.vala"
		_g_free0 (body);
#line 185 "../src/notifications-capability.vala"
		_g_free0 (_tmp3_);
#line 185 "../src/notifications-capability.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 185 "../src/notifications-capability.vala"
		g_clear_error (&_inner_error0_);
#line 185 "../src/notifications-capability.vala"
		return;
#line 1172 "notifications-capability.c"
	}
#line 192 "../src/notifications-capability.vala"
	if (self->priv->have_actions) {
#line 1176 "notifications-capability.c"
		PomodoroTimer* _tmp17_;
		PomodoroTimerState* _tmp18_;
		PomodoroTimerState* _tmp19_;
		GVariant* _tmp24_;
		GVariant* _tmp25_;
#line 194 "../src/notifications-capability.vala"
		g_notification_set_default_action (notification, "app.show-screen-notification");
#line 196 "../src/notifications-capability.vala"
		_tmp17_ = self->priv->timer;
#line 196 "../src/notifications-capability.vala"
		_tmp18_ = pomodoro_timer_get_state (_tmp17_);
#line 196 "../src/notifications-capability.vala"
		_tmp19_ = _tmp18_;
#line 196 "../src/notifications-capability.vala"
		if (POMODORO_IS_SHORT_BREAK_STATE (_tmp19_)) {
#line 1192 "notifications-capability.c"
			GVariant* _tmp20_;
			GVariant* _tmp21_;
#line 197 "../src/notifications-capability.vala"
			_tmp20_ = g_variant_new_string ("long-break");
#line 197 "../src/notifications-capability.vala"
			g_variant_ref_sink (_tmp20_);
#line 197 "../src/notifications-capability.vala"
			_tmp21_ = _tmp20_;
#line 197 "../src/notifications-capability.vala"
			g_notification_add_button_with_target_value (notification, _ ("Lengthen it"), "app.timer-switch-state", _tmp21_);
#line 197 "../src/notifications-capability.vala"
			_g_variant_unref0 (_tmp21_);
#line 1205 "notifications-capability.c"
		} else {
			GVariant* _tmp22_;
			GVariant* _tmp23_;
#line 202 "../src/notifications-capability.vala"
			_tmp22_ = g_variant_new_string ("short-break");
#line 202 "../src/notifications-capability.vala"
			g_variant_ref_sink (_tmp22_);
#line 202 "../src/notifications-capability.vala"
			_tmp23_ = _tmp22_;
#line 202 "../src/notifications-capability.vala"
			g_notification_add_button_with_target_value (notification, _ ("Shorten it"), "app.timer-switch-state", _tmp23_);
#line 202 "../src/notifications-capability.vala"
			_g_variant_unref0 (_tmp23_);
#line 1219 "notifications-capability.c"
		}
#line 207 "../src/notifications-capability.vala"
		_tmp24_ = g_variant_new_string ("pomodoro");
#line 207 "../src/notifications-capability.vala"
		g_variant_ref_sink (_tmp24_);
#line 207 "../src/notifications-capability.vala"
		_tmp25_ = _tmp24_;
#line 207 "../src/notifications-capability.vala"
		g_notification_add_button_with_target_value (notification, _ ("Start pomodoro"), "app.timer-set-state", _tmp25_);
#line 207 "../src/notifications-capability.vala"
		_g_variant_unref0 (_tmp25_);
#line 1231 "notifications-capability.c"
	}
#line 212 "../src/notifications-capability.vala"
	_tmp26_ = g_application_get_default ();
#line 212 "../src/notifications-capability.vala"
	g_application_send_notification (_tmp26_, "timer", notification);
#line 166 "../src/notifications-capability.vala"
	_g_object_unref0 (notification);
#line 166 "../src/notifications-capability.vala"
	_g_free0 (body);
#line 166 "../src/notifications-capability.vala"
	_g_free0 (_tmp3_);
#line 1243 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_on_settings_changed (PomodoroNotificationsCapability* self,
                                                       GSettings* settings,
                                                       const gchar* key)
{
	const gchar* _tmp0_;
	GQuark _tmp2_ = 0U;
#line 219 "../src/notifications-capability.vala"
	static GQuark _tmp1_label0 = 0;
#line 216 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/notifications-capability.vala"
	g_return_if_fail (settings != NULL);
#line 216 "../src/notifications-capability.vala"
	g_return_if_fail (key != NULL);
#line 219 "../src/notifications-capability.vala"
	_tmp0_ = key;
#line 219 "../src/notifications-capability.vala"
	_tmp2_ = (NULL == _tmp0_) ? 0 : g_quark_from_string (_tmp0_);
#line 219 "../src/notifications-capability.vala"
	if (_tmp2_ == ((0 != _tmp1_label0) ? _tmp1_label0 : (_tmp1_label0 = g_quark_from_static_string ("show-screen-notifications")))) {
#line 219 "../src/notifications-capability.vala"
		switch (0) {
#line 1269 "notifications-capability.c"
			default:
			{
				PomodoroTimer* _tmp3_;
				PomodoroTimerState* _tmp4_;
				PomodoroTimerState* _tmp5_;
#line 222 "../src/notifications-capability.vala"
				_tmp3_ = self->priv->timer;
#line 222 "../src/notifications-capability.vala"
				_tmp4_ = pomodoro_timer_get_state (_tmp3_);
#line 222 "../src/notifications-capability.vala"
				_tmp5_ = _tmp4_;
#line 222 "../src/notifications-capability.vala"
				if (POMODORO_IS_BREAK_STATE (_tmp5_)) {
#line 223 "../src/notifications-capability.vala"
					pomodoro_notifications_capability_notify_pomodoro_end (self);
#line 1285 "notifications-capability.c"
				}
#line 226 "../src/notifications-capability.vala"
				break;
#line 1289 "notifications-capability.c"
			}
		}
	}
}

static void
pomodoro_notifications_capability_on_timer_state_changed (PomodoroNotificationsCapability* self,
                                                          PomodoroTimerState* state,
                                                          PomodoroTimerState* previous_state)
{
#line 230 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 230 "../src/notifications-capability.vala"
	g_return_if_fail (state != NULL);
#line 230 "../src/notifications-capability.vala"
	g_return_if_fail (previous_state != NULL);
#line 233 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_withdraw_notifications (self);
#line 235 "../src/notifications-capability.vala"
	if (POMODORO_IS_POMODORO_STATE (state)) {
#line 236 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_notify_pomodoro_start (self);
#line 1312 "notifications-capability.c"
	} else {
#line 238 "../src/notifications-capability.vala"
		if (POMODORO_IS_BREAK_STATE (state)) {
#line 239 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_notify_pomodoro_end (self);
#line 1318 "notifications-capability.c"
		}
	}
}

static void
pomodoro_notifications_capability_on_timer_state_duration_notify (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 243 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 245 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 245 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 245 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 245 "../src/notifications-capability.vala"
	if (!_tmp2_) {
#line 1339 "notifications-capability.c"
		PomodoroTimer* _tmp3_;
		PomodoroTimerState* _tmp4_;
		PomodoroTimerState* _tmp5_;
		PomodoroTimer* _tmp6_;
		PomodoroTimerState* _tmp7_;
		PomodoroTimerState* _tmp8_;
#line 246 "../src/notifications-capability.vala"
		_tmp3_ = self->priv->timer;
#line 246 "../src/notifications-capability.vala"
		_tmp4_ = pomodoro_timer_get_state (_tmp3_);
#line 246 "../src/notifications-capability.vala"
		_tmp5_ = _tmp4_;
#line 246 "../src/notifications-capability.vala"
		if (POMODORO_IS_POMODORO_STATE (_tmp5_)) {
#line 247 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_show_pomodoro_start_notification (self);
#line 1356 "notifications-capability.c"
		}
#line 250 "../src/notifications-capability.vala"
		_tmp6_ = self->priv->timer;
#line 250 "../src/notifications-capability.vala"
		_tmp7_ = pomodoro_timer_get_state (_tmp6_);
#line 250 "../src/notifications-capability.vala"
		_tmp8_ = _tmp7_;
#line 250 "../src/notifications-capability.vala"
		if (POMODORO_IS_BREAK_STATE (_tmp8_)) {
#line 251 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_show_pomodoro_end_notification (self);
#line 1368 "notifications-capability.c"
		}
	}
}

static gboolean
___lambda36_ (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	PomodoroTimerState* _tmp1_;
	PomodoroTimerState* _tmp2_;
	gboolean result;
#line 263 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 263 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_state (_tmp0_);
#line 263 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 263 "../src/notifications-capability.vala"
	if (POMODORO_IS_POMODORO_STATE (_tmp2_)) {
#line 264 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_notify_pomodoro_start (self);
#line 1390 "notifications-capability.c"
	} else {
		PomodoroTimer* _tmp3_;
		PomodoroTimerState* _tmp4_;
		PomodoroTimerState* _tmp5_;
#line 266 "../src/notifications-capability.vala"
		_tmp3_ = self->priv->timer;
#line 266 "../src/notifications-capability.vala"
		_tmp4_ = pomodoro_timer_get_state (_tmp3_);
#line 266 "../src/notifications-capability.vala"
		_tmp5_ = _tmp4_;
#line 266 "../src/notifications-capability.vala"
		if (POMODORO_IS_BREAK_STATE (_tmp5_)) {
#line 267 "../src/notifications-capability.vala"
			pomodoro_notifications_capability_notify_pomodoro_end (self);
#line 1405 "notifications-capability.c"
		}
	}
#line 270 "../src/notifications-capability.vala"
	result = G_SOURCE_REMOVE;
#line 270 "../src/notifications-capability.vala"
	return result;
#line 1412 "notifications-capability.c"
}

static gboolean
____lambda36__gsource_func (gpointer self)
{
	gboolean result;
	result = ___lambda36_ ((PomodoroNotificationsCapability*) self);
#line 262 "../src/notifications-capability.vala"
	return result;
#line 1422 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_on_timer_is_paused_notify (PomodoroNotificationsCapability* self)
{
	PomodoroTimer* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 256 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 258 "../src/notifications-capability.vala"
	_tmp0_ = self->priv->timer;
#line 258 "../src/notifications-capability.vala"
	_tmp1_ = pomodoro_timer_get_is_paused (_tmp0_);
#line 258 "../src/notifications-capability.vala"
	_tmp2_ = _tmp1_;
#line 258 "../src/notifications-capability.vala"
	if (_tmp2_) {
#line 259 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_withdraw_notifications (self);
#line 1443 "notifications-capability.c"
	} else {
#line 262 "../src/notifications-capability.vala"
		g_idle_add_full (G_PRIORITY_DEFAULT_IDLE, ____lambda36__gsource_func, g_object_ref (self), g_object_unref);
#line 1447 "notifications-capability.c"
	}
}

static void
pomodoro_notifications_capability_on_show_screen_notification_activate (PomodoroNotificationsCapability* self,
                                                                        GSimpleAction* action,
                                                                        GVariant* parameter)
{
#line 275 "../src/notifications-capability.vala"
	g_return_if_fail (self != NULL);
#line 275 "../src/notifications-capability.vala"
	g_return_if_fail (action != NULL);
#line 278 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_show_screen_notification (self);
#line 1462 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_show_screen_notification_activate_g_simple_action_activate (GSimpleAction* _sender,
                                                                                                  GVariant* parameter,
                                                                                                  gpointer self)
{
#line 285 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_show_screen_notification_activate ((PomodoroNotificationsCapability*) self, _sender, parameter);
#line 1472 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_timer_state_changed_pomodoro_timer_state_changed (PomodoroTimer* _sender,
                                                                                        PomodoroTimerState* state,
                                                                                        PomodoroTimerState* previous_state,
                                                                                        gpointer self)
{
#line 291 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_timer_state_changed ((PomodoroNotificationsCapability*) self, state, previous_state);
#line 1483 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_timer_state_duration_notify_g_object_notify (GObject* _sender,
                                                                                   GParamSpec* pspec,
                                                                                   gpointer self)
{
#line 292 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_timer_state_duration_notify ((PomodoroNotificationsCapability*) self);
#line 1493 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_timer_is_paused_notify_g_object_notify (GObject* _sender,
                                                                              GParamSpec* pspec,
                                                                              gpointer self)
{
#line 293 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_timer_is_paused_notify ((PomodoroNotificationsCapability*) self);
#line 1503 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_settings_changed_g_settings_changed (GSettings* _sender,
                                                                           const gchar* key,
                                                                           gpointer self)
{
#line 296 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_settings_changed ((PomodoroNotificationsCapability*) self, _sender, key);
#line 1513 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_real_enable (PomodoroCapability* base)
{
	PomodoroNotificationsCapability * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 281 "../src/notifications-capability.vala"
	self = (PomodoroNotificationsCapability*) base;
#line 283 "../src/notifications-capability.vala"
	_tmp0_ = pomodoro_capability_get_enabled ((PomodoroCapability*) self);
#line 283 "../src/notifications-capability.vala"
	_tmp1_ = _tmp0_;
#line 283 "../src/notifications-capability.vala"
	if (!_tmp1_) {
#line 1530 "notifications-capability.c"
		GSimpleAction* show_screen_notification_action = NULL;
		GSimpleAction* _tmp2_;
		GSimpleAction* _tmp3_;
		GApplication* application = NULL;
		GApplication* _tmp4_;
		GApplication* _tmp5_;
		GApplication* _tmp6_;
		GSimpleAction* _tmp7_;
		PomodoroTimer* _tmp8_;
		PomodoroTimer* _tmp9_;
		PomodoroTimer* _tmp10_;
		PomodoroTimer* _tmp11_;
		PomodoroTimer* _tmp12_;
		GSettings* _tmp13_;
		GSettings* _tmp14_;
		GSettings* _tmp15_;
		PomodoroTimer* _tmp16_;
		PomodoroTimerState* _tmp17_;
		PomodoroTimerState* _tmp18_;
		PomodoroTimer* _tmp19_;
		PomodoroTimerState* _tmp20_;
		PomodoroTimerState* _tmp21_;
#line 284 "../src/notifications-capability.vala"
		_tmp2_ = g_simple_action_new ("show-screen-notification", NULL);
#line 284 "../src/notifications-capability.vala"
		show_screen_notification_action = _tmp2_;
#line 285 "../src/notifications-capability.vala"
		_tmp3_ = show_screen_notification_action;
#line 285 "../src/notifications-capability.vala"
		g_signal_connect_object (_tmp3_, "activate", (GCallback) _pomodoro_notifications_capability_on_show_screen_notification_activate_g_simple_action_activate, self, 0);
#line 287 "../src/notifications-capability.vala"
		_tmp4_ = g_application_get_default ();
#line 287 "../src/notifications-capability.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 287 "../src/notifications-capability.vala"
		application = _tmp5_;
#line 288 "../src/notifications-capability.vala"
		_tmp6_ = application;
#line 288 "../src/notifications-capability.vala"
		_tmp7_ = show_screen_notification_action;
#line 288 "../src/notifications-capability.vala"
		g_action_map_add_action ((GActionMap*) _tmp6_, (GAction*) _tmp7_);
#line 290 "../src/notifications-capability.vala"
		_tmp8_ = pomodoro_timer_get_default ();
#line 290 "../src/notifications-capability.vala"
		_tmp9_ = _g_object_ref0 (_tmp8_);
#line 290 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->timer);
#line 290 "../src/notifications-capability.vala"
		self->priv->timer = _tmp9_;
#line 291 "../src/notifications-capability.vala"
		_tmp10_ = self->priv->timer;
#line 291 "../src/notifications-capability.vala"
		g_signal_connect_object (_tmp10_, "state-changed", (GCallback) _pomodoro_notifications_capability_on_timer_state_changed_pomodoro_timer_state_changed, self, G_CONNECT_AFTER);
#line 292 "../src/notifications-capability.vala"
		_tmp11_ = self->priv->timer;
#line 292 "../src/notifications-capability.vala"
		g_signal_connect_object ((GObject*) _tmp11_, "notify::state-duration", (GCallback) _pomodoro_notifications_capability_on_timer_state_duration_notify_g_object_notify, self, 0);
#line 293 "../src/notifications-capability.vala"
		_tmp12_ = self->priv->timer;
#line 293 "../src/notifications-capability.vala"
		g_signal_connect_object ((GObject*) _tmp12_, "notify::is-paused", (GCallback) _pomodoro_notifications_capability_on_timer_is_paused_notify_g_object_notify, self, 0);
#line 295 "../src/notifications-capability.vala"
		_tmp13_ = pomodoro_get_settings ();
#line 295 "../src/notifications-capability.vala"
		_tmp14_ = g_settings_get_child (_tmp13_, "preferences");
#line 295 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->settings);
#line 295 "../src/notifications-capability.vala"
		self->priv->settings = _tmp14_;
#line 296 "../src/notifications-capability.vala"
		_tmp15_ = self->priv->settings;
#line 296 "../src/notifications-capability.vala"
		g_signal_connect_object (_tmp15_, "changed", (GCallback) _pomodoro_notifications_capability_on_settings_changed_g_settings_changed, self, 0);
#line 298 "../src/notifications-capability.vala"
		_tmp16_ = self->priv->timer;
#line 298 "../src/notifications-capability.vala"
		_tmp17_ = pomodoro_timer_get_state (_tmp16_);
#line 298 "../src/notifications-capability.vala"
		_tmp18_ = _tmp17_;
#line 298 "../src/notifications-capability.vala"
		_tmp19_ = self->priv->timer;
#line 298 "../src/notifications-capability.vala"
		_tmp20_ = pomodoro_timer_get_state (_tmp19_);
#line 298 "../src/notifications-capability.vala"
		_tmp21_ = _tmp20_;
#line 298 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_on_timer_state_changed (self, _tmp18_, _tmp21_);
#line 283 "../src/notifications-capability.vala"
		_g_object_unref0 (application);
#line 283 "../src/notifications-capability.vala"
		_g_object_unref0 (show_screen_notification_action);
#line 1623 "notifications-capability.c"
	}
#line 302 "../src/notifications-capability.vala"
	POMODORO_CAPABILITY_CLASS (pomodoro_notifications_capability_parent_class)->enable (G_TYPE_CHECK_INSTANCE_CAST (self, POMODORO_TYPE_CAPABILITY, PomodoroCapability));
#line 1627 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_real_disable (PomodoroCapability* base)
{
	PomodoroNotificationsCapability * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 305 "../src/notifications-capability.vala"
	self = (PomodoroNotificationsCapability*) base;
#line 307 "../src/notifications-capability.vala"
	_tmp0_ = pomodoro_capability_get_enabled ((PomodoroCapability*) self);
#line 307 "../src/notifications-capability.vala"
	_tmp1_ = _tmp0_;
#line 307 "../src/notifications-capability.vala"
	if (_tmp1_) {
#line 1644 "notifications-capability.c"
		PomodoroTimer* _tmp2_;
		guint _tmp3_;
		PomodoroTimer* _tmp4_;
		guint _tmp5_;
		GQuark _tmp6_;
		PomodoroTimer* _tmp7_;
		guint _tmp8_;
		GQuark _tmp9_;
		GSettings* _tmp10_;
		guint _tmp11_;
		GApplication* application = NULL;
		GApplication* _tmp12_;
		GApplication* _tmp13_;
		GApplication* _tmp14_;
#line 308 "../src/notifications-capability.vala"
		pomodoro_notifications_capability_withdraw_notifications (self);
#line 310 "../src/notifications-capability.vala"
		_tmp2_ = self->priv->timer;
#line 310 "../src/notifications-capability.vala"
		g_signal_parse_name ("state-changed", POMODORO_TYPE_TIMER, &_tmp3_, NULL, FALSE);
#line 310 "../src/notifications-capability.vala"
		g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _pomodoro_notifications_capability_on_timer_state_changed_pomodoro_timer_state_changed, self);
#line 311 "../src/notifications-capability.vala"
		_tmp4_ = self->priv->timer;
#line 311 "../src/notifications-capability.vala"
		g_signal_parse_name ("notify::state-duration", G_TYPE_OBJECT, &_tmp5_, &_tmp6_, TRUE);
#line 311 "../src/notifications-capability.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, _tmp6_, NULL, (GCallback) _pomodoro_notifications_capability_on_timer_state_duration_notify_g_object_notify, self);
#line 312 "../src/notifications-capability.vala"
		_tmp7_ = self->priv->timer;
#line 312 "../src/notifications-capability.vala"
		g_signal_parse_name ("notify::is-paused", G_TYPE_OBJECT, &_tmp8_, &_tmp9_, TRUE);
#line 312 "../src/notifications-capability.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp7_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_DETAIL | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp8_, _tmp9_, NULL, (GCallback) _pomodoro_notifications_capability_on_timer_is_paused_notify_g_object_notify, self);
#line 313 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->timer);
#line 313 "../src/notifications-capability.vala"
		self->priv->timer = NULL;
#line 315 "../src/notifications-capability.vala"
		_tmp10_ = self->priv->settings;
#line 315 "../src/notifications-capability.vala"
		g_signal_parse_name ("changed", g_settings_get_type (), &_tmp11_, NULL, FALSE);
#line 315 "../src/notifications-capability.vala"
		g_signal_handlers_disconnect_matched (_tmp10_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp11_, 0, NULL, (GCallback) _pomodoro_notifications_capability_on_settings_changed_g_settings_changed, self);
#line 316 "../src/notifications-capability.vala"
		_g_object_unref0 (self->priv->settings);
#line 316 "../src/notifications-capability.vala"
		self->priv->settings = NULL;
#line 318 "../src/notifications-capability.vala"
		_tmp12_ = g_application_get_default ();
#line 318 "../src/notifications-capability.vala"
		_tmp13_ = _g_object_ref0 (_tmp12_);
#line 318 "../src/notifications-capability.vala"
		application = _tmp13_;
#line 319 "../src/notifications-capability.vala"
		_tmp14_ = application;
#line 319 "../src/notifications-capability.vala"
		g_action_map_remove_action ((GActionMap*) _tmp14_, "show-screen-notification");
#line 307 "../src/notifications-capability.vala"
		_g_object_unref0 (application);
#line 1705 "notifications-capability.c"
	}
#line 322 "../src/notifications-capability.vala"
	POMODORO_CAPABILITY_CLASS (pomodoro_notifications_capability_parent_class)->disable (G_TYPE_CHECK_INSTANCE_CAST (self, POMODORO_TYPE_CAPABILITY, PomodoroCapability));
#line 1709 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_real_dispose (GObject* base)
{
	PomodoroNotificationsCapability * self;
#line 325 "../src/notifications-capability.vala"
	self = (PomodoroNotificationsCapability*) base;
#line 327 "../src/notifications-capability.vala"
	if (self->priv->watcher_id != ((guint) 0)) {
#line 328 "../src/notifications-capability.vala"
		g_bus_unwatch_name (self->priv->watcher_id);
#line 329 "../src/notifications-capability.vala"
		self->priv->watcher_id = (guint) 0;
#line 1724 "notifications-capability.c"
	}
#line 332 "../src/notifications-capability.vala"
	G_OBJECT_CLASS (pomodoro_notifications_capability_parent_class)->dispose ((GObject*) G_TYPE_CHECK_INSTANCE_CAST (self, POMODORO_TYPE_CAPABILITY, PomodoroCapability));
#line 1728 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_name_appeared_gbus_name_appeared_callback (GDBusConnection* connection,
                                                                                 const gchar* name,
                                                                                 const gchar* name_owner,
                                                                                 gpointer self)
{
#line 49 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_name_appeared ((PomodoroNotificationsCapability*) self, connection, name, name_owner);
#line 1739 "notifications-capability.c"
}

static void
_pomodoro_notifications_capability_on_name_vanished_gbus_name_vanished_callback (GDBusConnection* connection,
                                                                                 const gchar* name,
                                                                                 gpointer self)
{
#line 49 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_on_name_vanished ((PomodoroNotificationsCapability*) self, connection, name);
#line 1749 "notifications-capability.c"
}

static GObject *
pomodoro_notifications_capability_constructor (GType type,
                                               guint n_construct_properties,
                                               GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	PomodoroNotificationsCapability * self;
#line 47 "../src/notifications-capability.vala"
	parent_class = G_OBJECT_CLASS (pomodoro_notifications_capability_parent_class);
#line 47 "../src/notifications-capability.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 47 "../src/notifications-capability.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_NOTIFICATIONS_CAPABILITY, PomodoroNotificationsCapability);
#line 49 "../src/notifications-capability.vala"
	self->priv->watcher_id = g_bus_watch_name_with_closures (G_BUS_TYPE_SESSION, "org.freedesktop.Notifications", G_BUS_NAME_WATCHER_FLAGS_NONE, (GClosure*) ((_pomodoro_notifications_capability_on_name_appeared_gbus_name_appeared_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _pomodoro_notifications_capability_on_name_appeared_gbus_name_appeared_callback, g_object_ref (self), (GClosureNotify) g_object_unref)), (GClosure*) ((_pomodoro_notifications_capability_on_name_vanished_gbus_name_vanished_callback == NULL) ? NULL : g_cclosure_new ((GCallback) _pomodoro_notifications_capability_on_name_vanished_gbus_name_vanished_callback, g_object_ref (self), (GClosureNotify) g_object_unref)));
#line 47 "../src/notifications-capability.vala"
	return obj;
#line 1770 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_class_init (PomodoroNotificationsCapabilityClass * klass,
                                              gpointer klass_data)
{
#line 37 "../src/notifications-capability.vala"
	pomodoro_notifications_capability_parent_class = g_type_class_peek_parent (klass);
#line 37 "../src/notifications-capability.vala"
	g_type_class_adjust_private_offset (klass, &PomodoroNotificationsCapability_private_offset);
#line 37 "../src/notifications-capability.vala"
	((PomodoroCapabilityClass *) klass)->enable = (void (*) (PomodoroCapability*)) pomodoro_notifications_capability_real_enable;
#line 37 "../src/notifications-capability.vala"
	((PomodoroCapabilityClass *) klass)->disable = (void (*) (PomodoroCapability*)) pomodoro_notifications_capability_real_disable;
#line 37 "../src/notifications-capability.vala"
	((GObjectClass *) klass)->dispose = (void (*) (GObject*)) pomodoro_notifications_capability_real_dispose;
#line 37 "../src/notifications-capability.vala"
	G_OBJECT_CLASS (klass)->constructor = pomodoro_notifications_capability_constructor;
#line 37 "../src/notifications-capability.vala"
	G_OBJECT_CLASS (klass)->finalize = pomodoro_notifications_capability_finalize;
#line 1791 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_instance_init (PomodoroNotificationsCapability * self,
                                                 gpointer klass)
{
#line 37 "../src/notifications-capability.vala"
	self->priv = pomodoro_notifications_capability_get_instance_private (self);
#line 42 "../src/notifications-capability.vala"
	self->priv->watcher_id = (guint) 0;
#line 44 "../src/notifications-capability.vala"
	self->priv->have_actions = FALSE;
#line 45 "../src/notifications-capability.vala"
	self->priv->have_persistence = FALSE;
#line 1806 "notifications-capability.c"
}

static void
pomodoro_notifications_capability_finalize (GObject * obj)
{
	PomodoroNotificationsCapability * self;
#line 37 "../src/notifications-capability.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, POMODORO_TYPE_NOTIFICATIONS_CAPABILITY, PomodoroNotificationsCapability);
#line 39 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->settings);
#line 40 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->timer);
#line 41 "../src/notifications-capability.vala"
	_g_object_unref0 (self->priv->screen_notification);
#line 37 "../src/notifications-capability.vala"
	G_OBJECT_CLASS (pomodoro_notifications_capability_parent_class)->finalize (obj);
#line 1823 "notifications-capability.c"
}

static GType
pomodoro_notifications_capability_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (PomodoroNotificationsCapabilityClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) pomodoro_notifications_capability_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PomodoroNotificationsCapability), 0, (GInstanceInitFunc) pomodoro_notifications_capability_instance_init, NULL };
	GType pomodoro_notifications_capability_type_id;
	pomodoro_notifications_capability_type_id = g_type_register_static (POMODORO_TYPE_CAPABILITY, "PomodoroNotificationsCapability", &g_define_type_info, 0);
	PomodoroNotificationsCapability_private_offset = g_type_add_instance_private (pomodoro_notifications_capability_type_id, sizeof (PomodoroNotificationsCapabilityPrivate));
	return pomodoro_notifications_capability_type_id;
}

GType
pomodoro_notifications_capability_get_type (void)
{
	static volatile gsize pomodoro_notifications_capability_type_id__once = 0;
	if (g_once_init_enter (&pomodoro_notifications_capability_type_id__once)) {
		GType pomodoro_notifications_capability_type_id;
		pomodoro_notifications_capability_type_id = pomodoro_notifications_capability_get_type_once ();
		g_once_init_leave (&pomodoro_notifications_capability_type_id__once, pomodoro_notifications_capability_type_id);
	}
	return pomodoro_notifications_capability_type_id__once;
}

static void
_vala_array_destroy (gpointer array,
                     gssize array_length,
                     GDestroyNotify destroy_func)
{
#line 29 "../src/aggregated-entry.vala"
	if ((array != NULL) && (destroy_func != NULL)) {
#line 1855 "notifications-capability.c"
		gssize i;
#line 29 "../src/aggregated-entry.vala"
		for (i = 0; i < array_length; i = i + 1) {
#line 29 "../src/aggregated-entry.vala"
			if (((gpointer*) array)[i] != NULL) {
#line 29 "../src/aggregated-entry.vala"
				destroy_func (((gpointer*) array)[i]);
#line 1863 "notifications-capability.c"
			}
		}
	}
}

static void
_vala_array_free (gpointer array,
                  gssize array_length,
                  GDestroyNotify destroy_func)
{
#line 29 "../src/aggregated-entry.vala"
	_vala_array_destroy (array, array_length, destroy_func);
#line 29 "../src/aggregated-entry.vala"
	g_free (array);
#line 1878 "notifications-capability.c"
}

